﻿using System;
using System.Numerics;
using System.Threading.Tasks;

namespace Faktorial
{
    public static class Faktorial
    {
        public static long fakt(long n)
        {
            if (n == 0 || n == 1) return 1;
            return n * fakt(n - 1);
        }

        public static BigInteger SerFaktorial(BigInteger n)
        {
            BigInteger output = 1;
            while (n > 0)
            {
                output = output * n;
                n--;
            }
            return output;
        }

        private static BigInteger SudyLichy(BigInteger n, BigInteger i) //začínáme od 2 min i = 2
        {
            BigInteger res = 1;
            for (; i <= n; i += 2)
                res = res * i;
            return res;
        }

        public static BigInteger ParalelFaktorial(BigInteger n)
        {
            var taskCount = Environment.ProcessorCount;
            var tasks = new Task<BigInteger>[taskCount];
            for (var i = 0; i < taskCount; i++)
                tasks[i] = Task<BigInteger>.Factory.StartNew(vstup =>
                {
                    var citac = (BigInteger) vstup;
                    var multiplikace = new BigInteger(1);
                    while (citac <= n)
                    {
                        multiplikace = multiplikace * citac;
                        citac = citac + taskCount;
                    }
                    return multiplikace;
                }, new BigInteger(i + 1));
            var vystup = new BigInteger(1);
            Task.WaitAll(tasks);
            foreach (var uloha in tasks)
                vystup = vystup * uloha.Result;
            return vystup;
        }
    }
}