﻿using System;
using System.Drawing;

namespace Mandelbrot
{
    public class Mandelbrotova
    {
        /*properties*/
        protected double Maxr;

        protected double Minr;

        protected double Maxi;

        protected double Mini;

        protected int Width;

        protected int Height;

        protected int IterationCount;
        /*.............................*/

        public Mandelbrotova(int width, int height, double maxr, double minr, double maxi, double mini, int iterationCount)
        {
            Maxr = maxr;
            Minr = minr;
            Maxi = maxi;
            Mini = mini;
            Width = width;
            Height = height;
            IterationCount = iterationCount;
        }

        public virtual Bitmap Mandel()
        {
            double dx, dy, cx, cy;
            Bitmap img = new Bitmap(Width, Height);
            double posunx = (Maxr - Minr) / Width;
            double posuny = (Maxi - Mini) / Height;
            double tempzx;

            for (int x = 0; x < Width; x++)
            {
                cx = posunx * x - Math.Abs(Minr);
                for (int y = 0; y < Height; y++)
                {
                    dx = 0;
                    dy = 0;
                    cy = posuny * y - Math.Abs(Mini);
                    int count = 0; // pocet iteraci
                    while (dx * dx + dy * dy <= 4 && count < IterationCount) /*Cyklus který určí krajní body a body které patří do množiny*/
                    {
                        count++;
                        tempzx = dx;
                        dx = dx * dx - dy * dy + cx;
                        dy = 2 * tempzx * dy + cy;
                    }
                    img.SetPixel(x, y, count != IterationCount ? Color.FromArgb(count % 128 * 2, count % 32 * 7, count % 16 * 14) : Color.Black);
                }
            }
            return img;
        }

        public Bitmap Zoom(int mouseX, int mouseY)
        {
            double posunX = (Maxr - Minr) / Width;
            double posunY = (Maxi - Mini) / Height;
            int zoomx = Width / 5;
            int zoomy = Height / 5;
            Maxr = (mouseX + zoomx) * posunX - Math.Abs(Minr);
            Minr = (mouseX - zoomx) * posunX - Math.Abs(Minr);
            Maxi = (mouseY + zoomy) * posunY - Math.Abs(Mini);
            Mini = (mouseY - zoomy) * posunY - Math.Abs(Mini);
            //zoom oblasti kliku myši
            Bitmap img = Mandel();
            return img;
        }
    }
}
