﻿using System;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using System.Collections.Generic;

namespace ParaScitaniPoli
{
    internal class Pole
    {
        private static bool _konec;
        private static SumClass _sumClass;
        private static Stopwatch _s;
    private static void Main()
        {
            _s = new Stopwatch();
            while (!_konec)
            {
                Console.WriteLine(
                    "Napište:\n" +
                    "1 pro nagenerování pole\n" +
                    "2 pro single test\n" +
                    "3 pro hromadný test pomocí metod\n" +
                    "0 pro konec programu\n");
                switch (int.Parse(Console.ReadLine()))
                {
                    case 0: //konec programu
                        _konec = true;
                        break;

                    case 1: //generování pole
                        Console.WriteLine("Zadejte pocet prvku");
                        _sumClass = new SumClass(int.Parse(Console.ReadLine()));
                        Console.WriteLine("generuji\n");
                        _sumClass.Generator();
                        _sumClass?.Dispose();
                        break;
                    case 2:
                        Crossing(1);
                        break;
                    case 3:
                        Crossing(2);
                        break;
                }

            }
        }

        private static void Crossing(int switchoption)
        {
            switch (switchoption)
            {
                case 1: //single tests
                    Console.WriteLine(
                        "1 pro součet v hlaním vlákně\n" +
                        "2 pro součet pomocí tasks\n" +
                        "3 pro součet pomocí paralelního cyklu\n" +
                        "4 pro součet pomocí Paralell.Invoke\n");
                    SingleTests(int.Parse(Console.ReadLine()));
                    break;
                case 2: //test class
                    Console.WriteLine(
                        "1 pro test hlaního vlákna\n" +
                        "2 pro test tasks\n" +
                        "3 pro test paralelního cyklu\n" +
                        "4 pro test Paralell.Invoke\n");
                    MultipleTests(int.Parse(Console.ReadLine()));
                    break;
            }
        }

        private static void SingleTests(int switchoption)
        {
            switch (switchoption)
            {
                case 1: //Součet klasicky(jen hlavní vlákno)
                    _s.Reset();
                    _s.Start();
                    _sumClass.Suma();
                    _s.Stop();
                    Console.WriteLine("Vysledek = " + _sumClass.Soucet);
                    Console.WriteLine("Cas " + _s.Elapsed + "\n");
                    break;
                case 2: //Součet pomocí Task
                    _s.Reset();
                    _s.Start();
                    _sumClass.SectiTasks();
                    _s.Stop();
                    Console.WriteLine("Vysledek = " + _sumClass.Soucet);
                    Console.WriteLine("Cas " + _s.Elapsed + "\n");
                    break;
                case 3: //Paralelní cyklus
                    _s.Reset();
                    _s.Start();
                    _sumClass.SectiParFor();
                    _s.Stop();
                    Console.WriteLine("Vysledek = " + _sumClass.Soucet);
                    Console.WriteLine("Cas " + _s.Elapsed + "\n");
                    break;
                case 4:
                    _s.Reset();
                    _s.Start();
                    _sumClass.SectiInvoke();
                    _s.Stop();
                    Console.WriteLine("Vysledek =" + _sumClass.Soucet);
                    Console.WriteLine("Cas " + _s.Elapsed + "\n");
                    break;
            }
        }
        private static void MultipleTests(int switchoption)
        {
            TestClass test = new TestClass();
            string pathToFile;
            switch (switchoption)
            {
                case 1: //Součet klasicky(jen hlavní vlákno)
                    _s.Reset();
                    _s.Start();
                    test.TestFuntion(_sumClass.Suma);
                    pathToFile = test.TimeResultsToFile("Main thread");
                    _s.Stop();
                    Console.WriteLine("Cas " + _s.Elapsed + "\n");
                    Console.WriteLine("Soubor s výslednými časy najdete v " + pathToFile + "\n");
                    break;
                case 2: //Součet pomocí Task
                    _s.Reset();
                    _s.Start();
                    test.TestFuntion(_sumClass.SectiTasks);
                    pathToFile = test.TimeResultsToFile("Tasks");
                    _s.Stop();
                    Console.WriteLine("Cas " + _s.Elapsed + "\n");
                    Console.WriteLine("Soubor s výslednými časy najdete v " + pathToFile + "\n");
                    break;
                case 3: //Paralelní cyklus
                    _s.Reset();
                    _s.Start();
                    test.TestFuntion(_sumClass.SectiParFor);
                    pathToFile = test.TimeResultsToFile("Paralel for");
                    _s.Stop();
                    Console.WriteLine("Cas " + _s.Elapsed + "\n");
                    Console.WriteLine("Soubor s výslednými časy najdete v " + pathToFile + "\n");
                    break;
                case 4:
                    _s.Reset();
                    _s.Start();
                    test.TestFuntion(_sumClass.SectiInvoke);
                    pathToFile = test.TimeResultsToFile("Invoke");
                    _s.Stop();
                    Console.WriteLine("Cas " + _s.Elapsed + "\n");
                    Console.WriteLine("Soubor s výslednými časy najdete v " + pathToFile + "\n");
                    break;
            }
        }
    }
}
