﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ParaScitaniPoli
{
    public class SumClass : IDisposable
    {
        public int Soucet { get; set; }
        private int[] _pole;
        private const int RndDo = 1000;
        private int _pocetPrvku;
        public SumClass(int pocetprvku)
        {
            _pocetPrvku = pocetprvku;
            _pole = new int[pocetprvku];
        }

        public void Generator()
        {
            var rnd = new Random();
            for (int i = 0; i < _pocetPrvku; i++)
            {
                _pole[i] = rnd.Next(RndDo);
            }
        }

        public void SectiTasks() //tasks
        {
            Soucet = 0;
            int pocet = _pole.Length;
            int interval = pocet / 2; //2 vlakna
            int zbytek = pocet % 2;
            var ukoly = new Task<int>[2];
            ukoly[0] = new Task<int>(() => Suma(0, interval));
            ukoly[0].Start();
            ukoly[1] = new Task<int>(() => Suma(interval, interval * 2 + zbytek));
            ukoly[1].Start();
            Soucet = ukoly[0].Result + ukoly[1].Result;
        }

        private int Suma(int od, int kam) // funkce na paralelní řeš. -> rozlišuje meze
        {
            int vysledek = 0;
            for (int j = od; j < kam; j++)
            {
                vysledek += _pole[j];
            }
            return vysledek;
        }

        public void Suma() //klasické sečtení prvků
        {
            Soucet = 0;
            //Soucet = _pole.Sum();
            foreach (int i in _pole)
            {
                Soucet += i;
            }
        }

        public void SectiParFor() //sečtení pomocí paralelního cyklu
        {
            Soucet = 0;
            object sync = new object(); //objek který poslouží jako zámek
            //Parallel.For(0, _pole.Length, i =>
            //{
            //    lock (sync)
            //    {
            //        Soucet +=  _pole[i];
            //    }
            //});
            Parallel.For(0, _pole.Length, () => 0, (vysl, pls, mezivysl) =>
            {
                return mezivysl += _pole[vysl];
            }, (lhod) =>
            {
                lock (sync)
                {
                    Soucet += lhod;
                }
            });
        }

        public void SectiInvoke()//parallel invoke stane se to samé jako při sériovém přístupu akorát se úloha spustí mimo hlavní vlákno
        {
            Soucet = 0;
            int pocet = _pole.Length;
            int interval = pocet / 2;
            int zbytek = pocet % 2;
            int vysl1;
            vysl1 = 0;
            Parallel.Invoke(() => vysl1 = Suma(0, interval));
            int vysl2 = Suma(interval, pocet + zbytek);
            Soucet = vysl1 + vysl2;
        }

        private int Secti(int a, int b)
        {
            return a + b;
        }

        public void Dispose()
        {
            GC.Collect();
        }
    }
}
