﻿using System.Threading;
using System.Threading.Tasks;

namespace Paralelni_nasobeni_matic
{
    class ParalelMatrixClass : SerialMatrixClass
    {
        public ParalelMatrixClass(int[,] matA, int[,] matB) : base(matA, matB)
        {
        }

        public virtual void Multiply(CancellationToken ct)
        {
            Parallel.For(0, MatA.GetLength(0), row =>
            {
                for (int col = 0; col < MatB.GetLength(1); col++)
                {
                    for (int inner = 0; inner < MatA.GetLength(1); inner++)
                    {
                        Result[row, col] += MatA[row, inner] * MatB[inner, col];
                    }
                    if (ct.IsCancellationRequested)
                    {
                        ct.ThrowIfCancellationRequested();
                    }
                }
            });
        }
    }
}