﻿using System.Collections.Generic;
using System.Linq;
using System.Threading;

namespace Paralelni_nasobeni_matic
{
    class SerialMatrixClass
    {
        public SerialMatrixClass(int[,] matA, int[,] matB)
        {
            MatA = matA;
            MatB = matB;
            Result = new int[MatA.GetLength(0), MatB.GetLength(1)];
        }

        public int[,] MatA { get; set; }
        public int[,] MatB { get; set; }
        public int[,] Result { get; }

        public virtual void Multiply(CancellationToken ct)
        {
            for (int row = 0; row < MatA.GetLength(0); row++)
            {
                for (int col = 0; col < MatB.GetLength(1); col++)
                {
                    for (int inner = 0; inner < MatA.GetLength(0); inner++)
                    {
                        Result[row, col] += MatA[row, inner] * MatB[inner, col];
                    }
                    if(ct.IsCancellationRequested)
                        ct.ThrowIfCancellationRequested();
                }
            }
        }
        public List<string> ResultAsStringList()
        {
            List<string> res = new List<string>();
            string result = "";
            for (int i = 0; i < MatA.GetLength(0); i++)
            {
                for (int j = 0; j < MatB.GetLength(1); j++)
                {
                    result += " " + Result[i, j];
                }
                res.Add(result);
                result = "";
            }
            return res;
        }
    }
}
