﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;

namespace Paralelni_nasobeni_matic
{
    class TestClass
    {
        private const int TestCount = 100;
        private readonly List<TimeSpan> _results;

        public TestClass()
        {
            _results = new List<TimeSpan>();
        }

        public void TestFuntion(Action action)
        {
            Stopwatch watch = new Stopwatch();
            for (int i = 0; i < TestCount; i++)
            {
                watch.Reset();
                watch.Start();
                action();
                watch.Stop();
                _results.Add(watch.Elapsed);
            }
        }

        public string TimeResultsToFile(string filename)
        {
            string path = Environment.CurrentDirectory + @"\" + filename + ".csv";
            FileInfo file = new FileInfo(path);
            using (StreamWriter writer = file.CreateText())
            {
                foreach (TimeSpan timeSpan in _results)
                {
                    writer.WriteLine(timeSpan.TotalMilliseconds + ";");
                }
                writer.Close();
            }
            return path;
        }

    }
}
